#!/usr/bin/env python

# This script installs or uninstalls Wallpapoz on your system.

import os, shutil, sys

INSTALL_DIR = '/usr/'

def info():
	
	print 'Run "python install.py install" as root to install Wallpapoz in /usr.'
	print 'To uninstall, simply run "python install.py uninstall".'
	print 'However you can run program right here in this directory.'
	print 'Installation is optional.'

if len(sys.argv) > 1:
	
	if os.path.isdir(INSTALL_DIR):
		
		if INSTALL_DIR.endswith('/'):
			INSTALL_DIR = INSTALL_DIR[:-1]
		
		if len(sys.argv) == 2:
			
			if sys.argv[1] == 'install':
				
				# Make new directories if they do not exist.
				if not os.path.exists(INSTALL_DIR + '/bin'):
					os.makedirs(INSTALL_DIR + '/bin', 0755)
				if not os.path.exists(INSTALL_DIR + '/share/applications'):
					os.makedirs(INSTALL_DIR + '/share/applications', 0755)
				if not os.path.exists(INSTALL_DIR + '/share/pixmaps'):
					os.makedirs(INSTALL_DIR + '/share/pixmaps', 0755)
				if not os.path.exists(INSTALL_DIR + '/share/wallpapoz'):
					os.makedirs(INSTALL_DIR + '/share/wallpapoz', 0755)
					
				# If the directories exist, copy the files to them.
				if os.path.isdir(INSTALL_DIR + '/bin'):
					shutil.copy('src/wallpapoz.py', INSTALL_DIR + '/bin/wallpapoz.py')
					os.chmod(INSTALL_DIR + '/bin/wallpapoz.py', 0755)
					print 'installed ' +  INSTALL_DIR + '/bin/wallpapoz.py'
					shutil.copy('src/xml_processing.py', INSTALL_DIR + '/bin/xml_processing.py')
					print 'installed ' +  INSTALL_DIR + '/bin/xml_processing.py'
					shutil.copy('src/daemon_wallpapoz.py', INSTALL_DIR + '/bin/daemon_wallpapoz.py')
					os.chmod(INSTALL_DIR + '/bin/daemon_wallpapoz.py', 0755)
					print 'installed ' +  INSTALL_DIR + '/bin/daemon_wallpapoz.py'
					
				if os.path.isdir(INSTALL_DIR + '/share/applications'):
					shutil.copy('share/wallpapoz/wallpapoz.desktop', INSTALL_DIR + '/share/applications/wallpapoz.desktop')
					os.chmod(INSTALL_DIR + '/share/applications/wallpapoz.desktop', 0644)
					print 'installed ' +  INSTALL_DIR + '/share/applications/wallpapoz.desktop'

				if os.path.isdir(INSTALL_DIR + '/share/wallpapoz'):
					shutil.copy('share/wallpapoz/wallpapoz.glade', INSTALL_DIR + '/share/wallpapoz/wallpapoz.glade')
					os.chmod(INSTALL_DIR + '/share/wallpapoz/wallpapoz.glade', 0644)
					print 'installed ' +  INSTALL_DIR + '/share/wallpapoz/wallpapoz.glade'
					shutil.copy('share/wallpapoz/wallpapoz.gladep', INSTALL_DIR + '/share/wallpapoz/wallpapoz.gladep')
					os.chmod(INSTALL_DIR + '/share/wallpapoz/wallpapoz.gladep', 0644)
					print 'installed ' +  INSTALL_DIR + '/share/wallpapoz/wallpapoz.gladep'
					shutil.copy('share/wallpapoz/wallpapoz.png', INSTALL_DIR + '/share/wallpapoz/wallpapoz.png')
					os.chmod(INSTALL_DIR + '/share/wallpapoz/wallpapoz.png', 0644)
					print 'installed ' +  INSTALL_DIR + '/share/wallpapoz/wallpapoz.png'
					
				if os.path.isdir(INSTALL_DIR + '/share/pixmaps'):
					shutil.copy('share/wallpapoz/wallpapoz.png', INSTALL_DIR + '/share/pixmaps/wallpapoz.png')
					os.chmod(INSTALL_DIR + '/share/pixmaps/wallpapoz.png', 0644)
					print 'installed ' +  INSTALL_DIR + '/share/pixmaps/wallpapoz.png'
					
			elif sys.argv[1] == 'uninstall':
				
				# Remove the files if they exist
				if os.path.exists(INSTALL_DIR + '/bin/wallpapoz.py'):
					os.remove(INSTALL_DIR + '/bin/wallpapoz.py')
					print 'removed ' +  INSTALL_DIR + '/bin/wallpapoz.py'
				if os.path.exists(INSTALL_DIR + '/bin/xml_processing.py'):
					os.remove(INSTALL_DIR + '/bin/xml_processing.py')
					print 'removed ' +  INSTALL_DIR + '/bin/xml_processing.py'
				if os.path.exists(INSTALL_DIR + '/bin/daemon_wallpapoz.py'):
					os.remove(INSTALL_DIR + '/bin/daemon_wallpapoz.py')
					print 'removed ' +  INSTALL_DIR + '/bin/daemon_wallpapoz.py'
				if os.path.exists(INSTALL_DIR + '/share/applications/wallpapoz.desktop'):
					os.remove(INSTALL_DIR + '/share/applications/wallpapoz.desktop')
					print 'removed ' +  INSTALL_DIR + '/share/applications/wallpapoz.desktop'
				if os.path.exists(INSTALL_DIR + '/share/wallpapoz/wallpapoz.glade'):
					os.remove(INSTALL_DIR + '/share/wallpapoz/wallpapoz.glade')
					print 'removed ' +  INSTALL_DIR + '/share/wallpapoz/wallpapoz.glade'
				if os.path.exists(INSTALL_DIR + '/share/wallpapoz/wallpapoz.gladep'):
					os.remove(INSTALL_DIR + '/share/wallpapoz/wallpapoz.gladep')
					print 'removed ' +  INSTALL_DIR + '/share/wallpapoz/wallpapoz.gladep'
				if os.path.exists(INSTALL_DIR + '/share/wallpapoz/wallpapoz.png'):
					os.remove(INSTALL_DIR + '/share/wallpapoz/wallpapoz.png')
					print 'removed ' +  INSTALL_DIR + '/share/wallpapoz/wallpapoz.png'
				if os.path.exists(INSTALL_DIR + '/share/pixmaps/wallpapoz.png'):
					os.remove(INSTALL_DIR + '/share/pixmaps/wallpapoz.png')
					print 'removed ' +  INSTALL_DIR + '/share/pixmaps/wallpapoz.png'
					
			else:
				info()
				
		else:
			info()
			
	else:
		print
		print INSTALL_DIR, 'does not exist.'
		info()
	
else:
	info()	
